/******************************************************************************

   Copyright 1991 Lee Iverson

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose without fee is hereby granted without fee,
   provided that the above copyright notice appear in all copies and that
   both that copyright notice and this permission notice appear in
   supporting documentation, and that the name of McGill not be used in
   advertising or publicity pertaining to distribution of the software
   without specific, written prior permission.  McGill makes no
   representations about the suitability of this software for any purpose.
   It is provided "as is" without express or implied warranty.

   MCGILL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL MCGILL
   BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
   OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
   CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

   Author:
     Lee Iverson <leei@mcrcim.mcgill.edu>,
     McGill Research Centre for Intelligent Machines (McRCIM)

   $Id: ImageP.h,v 0.9.1.4 1991/12/20 14:22:41 leei Exp $

******************************************************************************/

#ifndef _ImageP_h
#define _ImageP_h

#include <vim/proto.h>
#include <vim/utils.h>
#include <vim/Image.h>

#define MIN_PIXELS (5)
#define MIN_SIZE   (10)
#define MIN_HIGH   (1)
#define MAX_GRID   (30)

extern double rint __((double));

void XParamsFromWidget __((ExternalParams *xparams, Widget w));

/* include superclass private header file */
#include <X11/CoreP.h>

typedef struct {
    int empty;
} ImageWidgetClassPart;

typedef struct _ImageWidgetClassRec {
    CoreClassPart		core_class;
    ImageWidgetClassPart	image_class;
} ImageWidgetClassRec;

extern ImageWidgetClassRec imageClassRec;

#include <vim/GenImage.h>
#include <vim/FileDialog.h>

typedef struct {
    /* resources */
    float mag_x;
    float mag_y;
    Boolean descr;
    Boolean grid;
    Boolean verbose;
    Pixel foreground_pixel;
    XFontStruct *grid_font;
    XFontStruct *descr_font;
    Dimension width;
    Dimension height;
    int displayN;
    /* private state */
    GC annotateGC;
    Widget menu;
    GenericDisplayParams *stack;
    int stack_total;
    int stack_len;
    Widget cvWidget;
    Widget stack_editor;
    Region last_region;
    Boolean redraws_delayed;
} ImageWidgetPart;

typedef struct _ImageWidgetRec {
    CorePart	core;
    ImageWidgetPart	image;
} ImageWidgetRec;

#endif /* _ImageP_h */
