/******************************************************************************

   Copyright 1991 Lee Iverson

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose without fee is hereby granted without fee,
   provided that the above copyright notice appear in all copies and that
   both that copyright notice and this permission notice appear in
   supporting documentation, and that the name of McGill not be used in
   advertising or publicity pertaining to distribution of the software
   without specific, written prior permission.  McGill makes no
   representations about the suitability of this software for any purpose.
   It is provided "as is" without express or implied warranty.

   MCGILL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL MCGILL
   BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
   OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
   CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

   Author:
     Lee Iverson <leei@mcrcim.mcgill.edu>,
     McGill Research Centre for Intelligent Machines (McRCIM)

   $Id: debug.h,v 0.9.1.3 1991/12/19 13:42:01 leei Exp $

******************************************************************************/

#ifndef _debug_h_
#define _debug_h_

#define DBG_MEM		(1<<1)
#define DBG_METH	(1<<2)
#define DBG_IM		(1<<3)
#define DBG_DISP	(1<<4)
#define DBG_CM		(1<<5)
#define DBG_LD		(1<<6)

#if !defined(DEBUG) || defined(EBUG)

#  define DEBUG(x) debug x

   int debug();
   extern int debug_mask;

#  define SET_DEBUG(x)	(debug_mask |= (x))
#  define CLR_DEBUG(x)	(debug_mask &= ~(x))
#  define CHK_DEBUG(x)	(debug_mask & (x))

#  define DEBUGGING (1)

#else /* !DEBUG */

#  undef DEBUG
#  define DEBUG(x)	(0)

#  define SET_DEBUG(x)	(0)
#  define CLR_DEBUG(x)	(0)
#  define CHK_DEBUG(x)	(0)

#  define DEBUGGING (0)

#endif /* !DEBUG */

#endif /* _debug_h_ */

