#include "strstr.h"

#ifdef NEED_STRSTR
/*
 * strstr - find first occurrence of wanted in s
 */

char *				/* found string, or NULL if none */
strstr _IMPL((s, wanted), _CONST char *s _AND _CONST char *wanted)
{
    register _CONST char *scan;
    register int len;
    register char firstc;
    extern int strcmp();
    extern int strlen();

    /*
     * The odd placement of the two tests is so "" is findable.
     * Also, we inline the first char for speed.
     * The ++ on scan has been moved down for optimization.
     */
    firstc = *wanted;
    len = strlen(wanted);
    for (scan = s; *scan != firstc || strncmp(scan, wanted, len) != 0; )
      if (*scan++ == '\0')
	return(NULL);
    return(scan);
}
#endif /* NEED_STRSTR */

#ifdef NEED_STRDUP
char *
strdup _IMPL((str), _CONST char *str )
{
    char *new = (char *) malloc( strlen(str)+1 );

    strcpy(new, str);
    return new;
}
#endif /* NEED_STRDUP */
